
;WURDE IM QUARZ-ZEIT-MODUS JUSTIERT !!!!!!!!!!!!!
;QUARZ-UHR LUFT IN 48STUNDEN (2TAGE) NUR 1SEC SCHNELLER.
;SIE LUFT ALSO VOR...

;BEGRSSUNGSTEXT "ES GEHT LOS" WURDE RAUSGENOMMEN.
;WEGEN ZU GROSSEM SPEICHERBEDARF
;ES GIBT SONST KEINEN SPIELRAUM MEHR   UM ZU NDERN

;****************************************************************************************
;*                           DCF77-BERLIN-UHR MIT LED-ANZEIGE VON DL3UKH                *
;*                           ===========================================                *
;*                                         08.01.17                                     *
;****************************************************************************************

    LIST    P=16F628A    
    TITLE   "ARABISCHE-UHR"

    INCLUDE <P16F628A.INC>

    ERRORLEVEL -302

;ALS PIC-IC WURDE GENOMMEN PIC16F628A

;DER QUARZ HAT 16,0000 MHZ ALSO T=0.0625SEC  T==TAKTZEIT 


__CONFIG   _HS_OSC & _WDT_OFF & _PWRTE_OFF & _BODEN_ON & _MCLRE_OFF & _LVP_OFF & _DATA_CP_OFF & _CP_OFF


;MAN KANN HIER DIE PIEPS-UHRZEIT NDERN
;ZEIT FR PIEPS ZUR VOLLEN STUNDE IN DER 00SEC  1SEC LANG
STELL_AB_HIER   EQU 0X07    ;ALSO JETZT AB 7UHR    // KLEINSTE UHRZEIT IST 0X00 / ALSO NULL UHR
STELL_BIS_HIER  EQU 0X22    ;ALSO JETZT BIS 22UHR  // GRSSTE UHRZEIT IST 0X23  / ALSO 23UHR
;ALSO
;MIT 0X00 BIS 0X23 PIEPST ES JEDE STUNDE AUCH IN DER NACHT !!!!!!!! 


;REGISTER (MAX. 80 STCK) ZUORDNEN NACHFOLGEND DER FESTEN REGISTERN
;FR PUSH+POP
W_STACK EQU 0X22       
S_STACK EQU 0X23       

;FR ZEITSCHLEIFEN
HELP1   EQU 0X24
HELP2   EQU 0X25

;FR ZEIT
H       EQU 0X26
MIN     EQU 0X27
SEC     EQU 0X28

;FR BEFEHL + DATEN
HELP    EQU 0X29
MERK    EQU 0X2A
BIT     EQU 0X2B
ENABLE  EQU 0X2C

;INTERRUPT-ZEIT
MULT0   EQU 0X2D
MULT1   EQU 0X2E

;DARSTELLEN SEC MIN H ARABISCH + ROEMISCH
HEL     EQU 0X2F

;DCF77
Z_LL    EQU 0X30
Z_LH    EQU 0X31
Z_IMP   EQU 0X32
Z_H     EQU 0X33
I_MIN   EQU 0X34
I_H     EQU 0X35
PAR     EQU 0X36
ZEITUM  EQU 0X37
FEHL    EQU 0X38
BLINK   EQU 0X39
NULL    EQU 0X3A

;VARIABLEN
BIT7    EQU 7       ; BIT 7
BIT6    EQU 6       ; BIT 6
BIT5    EQU 5       ; BIT 5
BIT4    EQU 4       ; BIT 4
BIT3    EQU 3       ; BIT 3 
BIT2    EQU 2       ; BIT 2
BIT1    EQU 1       ; BIT 1 
BIT0    EQU 0       ; BIT 0

;======================= FUER LCD-MODUL ===========================
RS                      EQU     3       ; PORTA BIT3 UMSCHALTEN BEFEHL/DATEN      BEI WRITE DATEN IST ES HIGH     BEI WRITE BEFEHL IST ES LOW

EN0                     EQU     0       ; PORTA BIT0 ENABLE FALLENDE FLANKE   FR SEC
EN1                     EQU     1       ; PORTA BIT1 ENABLE FALLENDE FLANKE   FR MIN
EN2                     EQU     2       ; PORTA BIT2 ENABLE FALLENDE FLANKE   FR H


;------------ MACROS ---------------------------------------------------------

PUSH    MACRO
        MOVWF   W_STACK
        MOVF    STATUS, W
        MOVWF   S_STACK
        ENDM

POP     MACRO
        MOVF    S_STACK, W
        MOVWF   STATUS
        SWAPF   W_STACK, F
        SWAPF   W_STACK, W
        ENDM

BANK0           MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                BCF     STATUS,RP0
                BCF     STATUS,RP1
                ENDM

BANK1           MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                BSF     STATUS,RP0
                BCF     STATUS,RP1
                ENDM

BANK2           MACRO                   ;MACRO TO SELECT DATA RAM BANK 2
                BCF     STATUS,RP0
                BSF     STATUS,RP1
                ENDM

BANK3           MACRO                   ;MACRO TO SELECT DATA RAM BANK 3
                BSF     STATUS,RP0
                BSF     STATUS,RP1
                ENDM

;------------------------- ENDE MACROS -----------------------------------------------


    ORG 0X0000
    GOTO MAIN           ; SPRUNG ZUM HAUPTPROGRAMM
    ORG 0X0004
    GOTO INTERRUPT      ; SPRUNG ZUM INTERRUPTPROGRAMM

    ORG 0X0008
;*****************************************************************************
;*                              HAUPTPROGRAMM                                *
;*                              22.09.02                                     *
;*****************************************************************************
MAIN        BANK0

;----------- INIT ALLE PORT'S ----------------------------------------------------
            CLRF    PORTA                           
            CLRF    PORTB
            MOVLW   0X07                    ;COMPARATORS ALLE AUS VOM PORT A
            MOVWF   CMCON
            BANK1 
            MOVLW   B'00010000'             ;INIT INPUT/OUTPUT AM PORTA --> ALS AUSGNGE DIE 0 ---RA4 DCF77-EINGANG DIE 1
            MOVWF   TRISA
            MOVLW   B'00000111'             ;INIT I/O PORTB ALLES AUSGAENGE AUSSER SCHALTER FR SEC / MIN / H RB0-RB2 ALS EINGANG DIE 1             
            MOVWF   TRISB

;INIT TIMER0
                MOVLW   B'10000011'   ;BIT0-2 011=PRESCALER16, BIT3 0=TMR0, BIT4 0=ENTFAELLT, 
                                      ;BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                MOVWF   OPTION_REG    

            BANK0

;ALLES AUS
            CLRF    PORTA                           
            CLRF    PORTB

;250MSEC ZEITSCHLEIFE
                MOVLW   D'250'                 ;ZEITSCHLEIFE LADEN IN W MIT DEZIMAL 50 ALSO---> 50*1MSEC=50MSEC
                MOVWF   HELP1
ZZS11           CALL    ZS1MSEC_T0            ;ZEITSCHLEIFE ABARBEITEN
                DECFSZ  HELP1, F
                GOTO    ZZS11

;INITIALISIERUNG DOT-MATRIX-LCD
                CLRF    ENABLE
                BSF     ENABLE, BIT2    ;FR H-ANZEIGE

                MOVLW   H'20'                 ;FUNCTION SET  4-BIT-LAENGE, 1-ZEILIG, 5X7FONT
                CALL    BEFEHL

                MOVLW   H'0C'                 ;DISPLAY ON/OFF   DISPLAY ON, CURSOR OFF, BLINK OFF
                CALL    BEFEHL

                CALL    LOE
;FR H-ANZEIGE
;            MOVLW   H'80' 
;            CALL    BEFEHL
;            MOVLW   "E"
;            CALL    DATEN

;            MOVLW   H'81' 
;            CALL    BEFEHL
;            MOVLW   "S"
;            CALL    DATEN

;INITIALISIERUNG DOT-MATRIX-LCD
                CLRF    ENABLE
                BSF     ENABLE, BIT1    ;FR MIN-ANZEIGE

                MOVLW   H'20'                 ;FUNCTION SET  4-BIT-LAENGE, 1-ZEILIG, 5X7FONT
                CALL    BEFEHL

                MOVLW   H'0C'                 ;DISPLAY ON/OFF   DISPLAY ON, CURSOR OFF, BLINK OFF
                CALL    BEFEHL

                CALL    LOE
;FR MIN-ANZEIGE
;            MOVLW   H'80' 
;            CALL    BEFEHL
;            MOVLW   "G"
;            CALL    DATEN

;            MOVLW   H'81' 
;            CALL    BEFEHL
;            MOVLW   "E"
;            CALL    DATEN

;            MOVLW   H'82' 
;            CALL    BEFEHL
;            MOVLW   "H"
;            CALL    DATEN

;            MOVLW   H'83' 
;            CALL    BEFEHL
;            MOVLW   "T"
;            CALL    DATEN

;INITIALISIERUNG DOT-MATRIX-LCD
                CLRF    ENABLE
                BSF     ENABLE, BIT0    ;FR SEC-ANZEIGE

                MOVLW   H'20'                 ;FUNCTION SET  4-BIT-LAENGE, 1-ZEILIG, 5X7FONT
                CALL    BEFEHL

                MOVLW   H'0C'                 ;DISPLAY ON/OFF   DISPLAY ON, CURSOR OFF, BLINK OFF
                CALL    BEFEHL

                CALL    LOE
;FR SEC-ANZEIGE
;            MOVLW   H'80' 
;            CALL    BEFEHL
;            MOVLW   "L"
;            CALL    DATEN

;            MOVLW   H'81' 
;            CALL    BEFEHL
;            MOVLW   "O"
;            CALL    DATEN

;            MOVLW   H'82' 
;            CALL    BEFEHL
;            MOVLW   "S"
;            CALL    DATEN

;----------- 20 SEC PAUSE DAMIT DCF-77-EMPFNGER GUT EINSCHWINGT -------------

;            MOVLW   D'5'
;            CALL    ZS1SEC_T1

;----------- GRUNDEINSTELLUNG FR NORMALE-QUARZ-UHR ------------------------------
;----------- UND ANZEIGE ---------------------------------------------------------

            CLRF    H
            CLRF    MIN
            CLRF    SEC
            CLRF    FEHL
            CLRF    BLINK
            CLRF    NULL

;NULL DARSTELLEN
;H-DARSTELLEN ARABISCH ROEMISCH

            CLRF    ENABLE
            BSF     ENABLE, BIT2    ;FR H-ANZEIGE

                        ;CALL    LOE

            BTFSC   PORTB, BIT2
            GOTO    HROEM

            MOVLW   H'80'                  
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "0"
            CALL    DATEN
            GOTO    WEI0

HROEM       MOVLW   H'80'                  
            CALL    BEFEHL
            MOVLW   H'30'
            CALL    DATEN

            MOVLW   H'81'                  
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

;MIN-DARSTELLEN ARABISCH ROEMISCH
WEI0        CLRF    ENABLE
            BSF     ENABLE, BIT1    ;FR MIN-ANZEIGE

                        ;CALL    LOE
 
            BTFSC   PORTB, BIT1
            GOTO    MINROEM

            MOVLW   H'80'                  
            CALL    BEFEHL
            MOVLW   "0"
            CALL    DATEN

            MOVLW   H'81'                  
            CALL    BEFEHL
            MOVLW   "0"
            CALL    DATEN

;            MOVLW   H'82'       ;GETRIXT                 
;            CALL    BEFEHL
;            MOVLW   " "
;            CALL    DATEN

;            MOVLW   H'83'                  
;            CALL    BEFEHL
;            MOVLW   " "
;            CALL    DATEN
            GOTO    WEI1

MINROEM     MOVLW   H'80'                  
            CALL    BEFEHL
            MOVLW   "0"
            CALL    DATEN

            MOVLW   H'81'                  
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

;            MOVLW   H'82'       ;GETRIXT                 
;            CALL    BEFEHL
;            MOVLW   " "
;            CALL    DATEN

;            MOVLW   H'83'                  
;            CALL    BEFEHL
;            MOVLW   " "
;            CALL    DATEN

;SEC-DARSTELLEN ARABISCH
WEI1        CLRF    ENABLE
            BSF     ENABLE, BIT0    ;FR SEC-ANZEIGE

                        ;CALL    LOE

            BTFSC   PORTB, BIT0
            GOTO    SECROEM

            MOVLW   H'80'                  
            CALL    BEFEHL
            MOVLW   H'30'
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   H'30'
            CALL    DATEN

;            MOVLW   H'82'   ;GETRIXT
;            CALL    BEFEHL
;            MOVLW   " "
;            CALL    DATEN
            GOTO    WEI

SECROEM     MOVLW   H'80'                  
            CALL    BEFEHL
            MOVLW   H'30'
            CALL    DATEN

            MOVLW   H'81'                  
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

;            MOVLW   H'82'      ;GETRIXT 
;            CALL    BEFEHL
;            MOVLW   " "
;            CALL    DATEN

;----------- INIT 1 SEC --------------------------------------------------------
;----------- ES WIRD TIMER1 GENOMMEN MIT INTERRUPT -------------------------------
;----------- ZEITBASIS DER NORMALEN QUARZ-UHR ------------------------------------

WEI     BCF     PIR1, TMR1IF        ; OVERFLOW 0 MACHEN
        BSF     INTCON, GIE         ; GLOBALER INTERRUPT ENABLE + PERIPHERAL INTERRUPT
        BSF     INTCON, PEIE        ;
        BANK1
        BSF     PIE1, TMR1IE        ; TIMER1 OVERFLOW-INTERRUPT ENABLE
        BANK0
        MOVLW   0X9E                ;
        MOVWF   TMR1L               ;
                                    ;
        MOVLW   0XAE                ;
        MOVWF   TMR1H               ;

        MOVLW   D'3'                ;
        MOVWF   MULT0

        MOVLW   D'8'  ;24MAL 3*8=24 
        MOVWF   MULT1

        MOVLW   0X31 ;
        MOVWF   T1CON              ;START TIMER 1

;1000MSEC : 24MAL DURCHLAUFEN = 41,666666MSEC
;ZEITBERECHNUNG FR 41,66666MSEC

;PRESCALER 8X  *  SYSTEM 4X  * TAKTZEIT ====> 8*4*0.0625SEC=2SEC 
;41,6666MSEC : 2SEC= 20833,333                                   
;DA ES 2 BYTE SIND FR DIE ZEIT IST DIE GRSSTE ZAHL 0XFFFF = D'65535'
;ALSO
;0XFFFF (D'65535') - 0X5161 = 0XAE9E 
;TMR1L = 0X9E  UND  TMR1H = 0XAE  DIES OBEN EINTRAGEN
;---------------------------------------------------------------------------------



;----------- DCF-SEC-IMPULS-ANFANG FINDEN ----------------------------------------
;OB BERHAUPT DCF77 MIT IMPULSEN ANLIEGT

SYN         CLRF    Z_LL
            CLRF    Z_LH

SEC0        CALL    ZS1MSEC_T0

            BTFSC   PORTA, BIT4
            GOTO    SEC1            ;HIGH-IMPULS-BEGINN ERKANNT

            INCFSZ  Z_LL, F         ;LOW-IMPULSLNGE ZHLEN MEHR ALS 255MSEC MERKEN IN Z_LH BIT0
            GOTO    SEC0        
            BSF     Z_LH, BIT0
            GOTO    SEC0

SEC1        BTFSC   Z_LH, BIT0      ;GRER ALS FF LOW-SEC-LCKE
            GOTO    LUECKE
            GOTO    SYN
 
;------------ DCF-MINUTEN LUECKE FINDEN ------------------------------------------

LUECKE      CLRF    Z_LL            ;MTE MIT HIGH IMPULS BEGINNEN
            CLRF    Z_LH            ;ES WERDEN NUR DIE LOW-ZEITEN GEMESSEN

L1          BTFSC   PORTA, BIT4
            GOTO    L2
 
            CALL    ZS1MSEC_T0

            INCFSZ  Z_LL, F
            GOTO    L1
            INCFSZ  Z_LH, F
            GOTO    L1
            GOTO    SYN             ;DCF IST NICHT DA, AUSWERTUNG NACH 0XFFFF 65.535MS
                                    ;ES BLINKT NICHT

L2          MOVLW   0X05            ;GRER ALS 0X0500 ALSO 1280MSEC
            SUBWF   Z_LH, W
            BTFSS   STATUS, C
            GOTO    LUECKE

;------------ DCF-IMPULSE ERFASSEN ---------------------------------------------

IMPULS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;NEU STARTEN INTERRUPT ZEIT
        BCF     PIR1, TMR1IF        ; OVERFLOW 0 MACHEN
 
        MOVLW   0X9E                ;
        MOVWF   TMR1L               ;
                                    ;
        MOVLW   0XAE                ;
        MOVWF   TMR1H               ;

        MOVLW   D'3'                ;
        MOVWF   MULT0

        MOVLW   D'8'  
        MOVWF   MULT1

        MOVLW   0X31 
        MOVWF   T1CON              ;START TIMER 1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


        CLRF    Z_IMP       ;BEGINNT MIT HIGH-IMPULS
        CLRF    I_MIN
        CLRF    I_H
        CLRF    PAR         ;UNGERADE PARITT BEGINN IST JETZT 0X00
        CLRF    FEHL
;FEHLER , LOESCHEN IN 00SEC
            MOVLW   H'87' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

I1      CLRF    Z_H

I2      BTFSS   PORTA, BIT4 ;HIGH-IMPULS MESSEN
        GOTO    I10         ;SPRUNG BEI LOW ZUR AUSWERTUNG
 
        CALL    ZS1MSEC_T0

        INCFSZ  Z_H, F          
        GOTO    I2
        CALL    FEHLER      ;BSF     PORTA, BIT3     ;FEHLER LED AN
        GOTO    SYN

;-----------------------------------------------------------------------------------
;IN DEN IMPULS-LNGEN-GRENZEN "Z_H" AUSWERTEN
I10     MOVLW   D'50' ;60      
        SUBWF   Z_H, W
        BTFSS   STATUS, C   ;GRER ALS 60MS SONST FEHLER
        GOTO    VOR
        MOVLW   D'140' ;140     
        SUBWF   Z_H, W
        BTFSC   STATUS, C   ;KLEINER ALS 140MS SONST FEHLER
        GOTO    SU
        MOVLW   D'0'
        MOVWF   Z_H
        GOTO    RECHN

SU      MOVLW   D'240' ;240     
        SUBWF   Z_H, W
        BTFSC   STATUS, C   ;KLEINER ALS 240MS SONST FEHLER
        GOTO    VOR
        MOVLW   D'150' ;160     
        SUBWF   Z_H, W
        BTFSS   STATUS, C   ;GRER ALS 160MS SONST FEHLER
        GOTO    VOR
        MOVLW   D'1'
        MOVWF   Z_H
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RECHN   MOVLW   D'37'       ;BEI GRER GLEICH 37 ANS ENDE
        SUBWF   Z_IMP, W
        BTFSC   STATUS, C
        GOTO    D_ENDE

        MOVLW   D'21'       ;BEI KLEINER 21 ANS ENDE
        SUBWF   Z_IMP, W
        BTFSS   STATUS, C
        GOTO    D_ENDE

;------------ JETZT GEHTS LOS ---------------------------------------

MI00    MOVLW   D'21'       ;1MIN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    I11
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_MIN, BIT0
        BTFSS   PAR, BIT0   ;PARITT
        GOTO    PA0
        BCF     PAR, BIT0
        GOTO    D_ENDE

PA0     BSF     PAR, BIT0
        GOTO    D_ENDE

I11     MOVLW   D'22'       ;2MIN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    I12
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_MIN, BIT1
        BTFSS   PAR, BIT0   ;PARITT
        GOTO    PA1
        BCF     PAR, BIT0
        GOTO    D_ENDE

PA1     BSF     PAR, BIT0
        GOTO    D_ENDE


I12     MOVLW   D'23'       ;4MIN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    I13
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_MIN, BIT2
        BTFSS   PAR, BIT0   ;PARITT
        GOTO    PA2
        BCF     PAR, BIT0
        GOTO    D_ENDE

PA2     BSF     PAR, BIT0
        GOTO    D_ENDE

I13     MOVLW   D'24'       ;8MIN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    I14
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_MIN, BIT3
        BTFSS   PAR, BIT0   ;PARITT
        GOTO    PA3
        BCF     PAR, BIT0
        GOTO    D_ENDE

PA3     BSF     PAR, BIT0
        GOTO    D_ENDE


I14     MOVLW   D'25'       ;10MIN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    I15
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_MIN, BIT4
        BTFSS   PAR, BIT0   ;PARITT
        GOTO    PA4
        BCF     PAR, BIT0
        GOTO    D_ENDE

PA4     BSF     PAR, BIT0
        GOTO    D_ENDE


I15     MOVLW   D'26'       ;20MIN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    I16
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_MIN, BIT5
        BTFSS   PAR, BIT0   ;PARITT
        GOTO    PA5
        BCF     PAR, BIT0
        GOTO    D_ENDE

PA5     BSF     PAR, BIT0
        GOTO    D_ENDE


I16     MOVLW   D'27'       ;40MIN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    I17
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_MIN, BIT6
        BTFSS   PAR, BIT0   ;PARITT
        GOTO    PA6
        BCF     PAR, BIT0
        GOTO    D_ENDE

PA6     BSF     PAR, BIT0
        GOTO    D_ENDE


I17     MOVLW   D'28'       ;PARITT
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    II1
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z   ;
        GOTO    IP1
        BTFSS   PAR, BIT0   ;
        GOTO    VOR
        GOTO    D_ENDE

IP1     BTFSC   PAR, BIT0
        GOTO    VOR
        GOTO    D_ENDE

II1     MOVLW   D'29'       ;1H
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    II2
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_H, BIT0
        BTFSS   PAR, BIT1   ;PARITT
        GOTO    PA7
        BCF     PAR, BIT1
        GOTO    D_ENDE

PA7     BSF     PAR, BIT1
        GOTO    D_ENDE

II2     MOVLW   D'30'       ;2H
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    II3
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_H, BIT1
        BTFSS   PAR, BIT1   ;PARITT
        GOTO    PA9
        BCF     PAR, BIT1
        GOTO    D_ENDE

PA9     BSF     PAR, BIT1
        GOTO    D_ENDE

II3     MOVLW   D'31'       ;4H
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    II4
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_H, BIT2
        BTFSS   PAR, BIT1   ;PARITT
        GOTO    PA10
        BCF     PAR, BIT1
        GOTO    D_ENDE

PA10    BSF     PAR, BIT1
        GOTO    D_ENDE


II4     MOVLW   D'32'       ;8H
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    II5
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_H, BIT3
        BTFSS   PAR, BIT1   ;PARITT
        GOTO    PA11
        BCF     PAR, BIT1
        GOTO    D_ENDE

PA11    BSF     PAR, BIT1
        GOTO    D_ENDE

II5     MOVLW   D'33'       ;10H
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    II6
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_H, BIT4
        BTFSS   PAR, BIT1   ;PARITT
        GOTO    PA12
        BCF     PAR, BIT1
        GOTO    D_ENDE

PA12    BSF     PAR, BIT1
        GOTO    D_ENDE

II6     MOVLW   D'34'       ;20H
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    II7
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_H, BIT5
        BTFSS   PAR, BIT1   ;PARITT
        GOTO    PA13
        BCF     PAR, BIT1
        GOTO    D_ENDE

PA13    BSF     PAR, BIT1
        GOTO    D_ENDE


II7     MOVLW   D'35'       ;PARITT
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    XIP1
        BTFSS   PAR, BIT1
        GOTO    VOR
        GOTO    D_ENDE

XIP1    BTFSC   PAR, BIT1
        GOTO    VOR
        GOTO    D_ENDE

;-----------------------------------------------------------------------------

VOR     CALL    FEHLER           ;FEHLER LED AN / ERST AUS WENN NULL SEC

D_ENDE  INCF    Z_IMP, F

        CLRF    Z_LL
        CLRF    Z_LH

;LOW-IMPULS ZEITBERSCHREITUNG
I111    BTFSC   PORTA, BIT4 
        GOTO    I111A

        CALL    ZS1MSEC_T0

        INCFSZ  Z_LL, F
        GOTO    I111
        INCFSZ  Z_LH, F
        GOTO    I111
        CALL    FEHLER          ;FEHLERANZEIGE
        GOTO    SYN             ;ZEITBERSCHREITUNG ES FEHLT DCF

;AB HIER HIGH-IMPULS
I111A   MOVLW   0X05            ;GRER ALS 0X0500 ALSO 1280MS CARRY == HIGH
        SUBWF   Z_LH, W
        BTFSC   STATUS, C
        GOTO    I59

        GOTO    I1              ;ES IST EINE SEC VORBEI  / JETZT IST ES EIN NEUER HIGH-IMPULS WELCHER ANLIEGT

;--------------- MINUTENLCKE AN DER RICHTIGEN STELLE ----------------------------
I59     MOVLW   D'59'       ;MIN-LCKEN ERKENNUNG OK???
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    IFEHL       ;FEHLER BEI IMPULSANZAHL
;---------------------------------------------------------------------------------

        BTFSC   FEHL, BIT0 
        GOTO    IMPULS   
        
        MOVF    I_MIN, W        ;HIER NEUE MINUTE
        MOVWF   MIN
        MOVF    I_H, W
        MOVWF   H
        CLRF    SEC
        BSF     NULL, BIT0

;BLINK AN
        BSF     BLINK, BIT0     ; AN
        GOTO    IMPULS

IFEHL   CALL    FEHLER          ;FEHLER LED AN
        GOTO    IMPULS ;SYN

;*****************************************************************************
;*                              FEHLER                                       *
;*                                                                           *
;*****************************************************************************
FEHLER      BSF      FEHL, BIT0
            RETURN

;*****************************************************************************
;*                              INTERRUPTPROGRAMM                            *
;*                                                                           *
;*****************************************************************************
INTERRUPT
            PUSH

            BCF T1CON, TMR1ON               ;STOP TIMER1        ;4T + 8TINTERRUPT? JUSTAGE
            BCF PIR1, TMR1IF                ;OVERFLOW 0 MACHEN  ;4T

            MOVLW   0X9E                    ;
            MOVWF   TMR1L                   ;
            MOVLW   0XAE                    ;
            MOVWF   TMR1H                   ;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;JUSTAGE 
        
            NOP                             ;4T ZUR JUSTAGE
            NOP                             ;4T
            NOP                             ;4T
            NOP                             ;4T
            NOP                             ;4T

            NOP                             ;4T
            NOP                             ;4T
            NOP                             ;4T

            MOVLW   0X31 
            MOVWF   T1CON              ;START TIMER 1

;1000MSEC : 24MAL DURCHLAUFEN = 41,666666MSEC
;ZEITBERECHNUNG FR 41,66666MSEC

;PRESCALER 8X  *  SYSTEM 4X  * TAKTZEIT ====> 8*4*0.0625SEC=2SEC 
;41,6666MSEC : 2SEC= 20833,333                                   
;DA ES 2 BYTE SIND FR DIE ZEIT IST DIE GRSSTE ZAHL 0XFFFF = D'65535'
;ALSO
;0XFFFF (D'65535') - 0X5161 = 0XAE9E 
;TMR1L = 0X9E  UND  TMR1H = 0XAE  DIES OBEN EINTRAGEN
;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;BLINK
            CLRF    ENABLE
            BSF     ENABLE, BIT2    ;FR H-ANZEIGE

            BTFSS   BLINK, BIT0
            GOTO    III2

        MOVLW   0X00
        SUBWF   SEC, W
        BTFSS   STATUS, Z
        GOTO    III1

            MOVLW   H'87' 
            CALL    BEFEHL
            MOVLW   "."
            CALL    DATEN
            GOTO    III2

III1        CLRF    BLINK

            MOVLW   H'87' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;VON 7UHR BIS 21UHR PIEPS

III2    MOVLW   0X00
        SUBWF   MIN, W
        BTFSS   STATUS, Z
        GOTO    WEITER1

        MOVLW   STELL_AB_HIER        
        SUBWF   H, W
        BTFSS   STATUS, C   ;GRER GLEICH ALS 7UHR DANN CARRY AUF HIGH
        GOTO    WEITER1
        MOVLW   STELL_BIS_HIER+1       
        SUBWF   H, W
        BTFSC   STATUS, C   ;KLEINER ALS 22UHR (ALSO 21UHR GEHT NOCH) DANN CARRY AUF LOW
        GOTO    WEITER1

        MOVLW   0X00
        SUBWF   SEC, W
        BTFSS   STATUS, Z
        GOTO    WEITER1
        BSF     PORTB, BIT3
        GOTO    WEITER3

WEITER1 BCF     PORTB, BIT3

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WEITER3                      ;ACHTUNG ACHTUNG DAMIT 00SEC DARGESTELLT WIRD BEI DCF77 STELLEN
        BTFSS   NULL, BIT0
        GOTO    WEITER4
        CLRF    NULL
        GOTO    HHHH
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;BERECHNUNG
;1000MSEC : 24MAL DURCHLAUFEN = 41,666666MSEC

WEITER4 DECFSZ  MULT0, F
        GOTO    ENDE1
        MOVLW   D'3'
        MOVWF   MULT0

        DECFSZ  MULT1, F
        GOTO    ENDE1
        MOVLW   D'8'  ;24      ;8*3=24 1SEC
        MOVWF   MULT1

;-----------------------------------------------------------------------------

;----------- SEKUNDEN, MINUTEN UND STUNDEN ZHLUNG DER NORMALEN QUARZ-ZEIT ---
        MOVF    SEC, W
        ANDLW   0X0F
        ADDLW   0X01
        SUBLW   0X0A
        BTFSS   STATUS, Z
        GOTO    PPP0

        MOVF    SEC, W
        ANDLW   0XF0
        ADDLW   0X10
        GOTO    PPP1

PPP0    MOVF    SEC, W
        ADDLW   0X01

PPP1    MOVWF   SEC
        SUBLW   0X60
        BTFSS   STATUS, Z
        GOTO    HHHH ;SE

        CLRF    SEC         ;
        MOVF    MIN, W
        ANDLW   0X0F
        ADDLW   0X01
        SUBLW   0X0A
        BTFSS   STATUS, Z
        GOTO    PPP2

        MOVF    MIN, W
        ANDLW   0XF0
        ADDLW   0X10
        GOTO    PPP3

PPP2    MOVF    MIN, W
        ADDLW   0X01

PPP3    MOVWF   MIN
        SUBLW   0X60
        BTFSS   STATUS, Z
        GOTO    HHHH ;MI

        CLRF    MIN
        MOVF    H, W
        ANDLW   0X0F
        ADDLW   0X01
        SUBLW   0X0A
        BTFSS   STATUS, Z
        GOTO    PPP4

        MOVF    H, W
        ANDLW   0XF0
        ADDLW   0X10
        GOTO    PPP5

PPP4    MOVF    H, W
        ADDLW   0X01

PPP5    MOVWF   H
        SUBLW   0X24
        BTFSS   STATUS, Z
        GOTO    HHHH  ;ENDE

        CLRF    H

;==========================================================


HHHH        CLRF    ENABLE
            BSF     ENABLE, BIT2    ;FR H-ANZEIGE

            MOVF    H, W                  
            MOVWF   HEL

                        CALL    LOE

;FEHLER ANZEIGEN
            BTFSS   FEHL, BIT0
            GOTO    HHHH1

            MOVLW   H'87' 
            CALL    BEFEHL
            MOVLW   ","
            CALL    DATEN

HHHH1       BTFSS   PORTB, BIT2
            GOTO    ARAH
            CALL    ROEMISCH
            GOTO    MI

;H-DARSTELLEN ARABISCH
ARAH        MOVLW   H'81'                  
            CALL    BEFEHL
            
            MOVF    HEL, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            MOVLW   H'80'                  
            CALL    BEFEHL

            SWAPF   HEL, W
            ANDLW   H'0F'
            ADDLW   H'30'

            SUBLW   H'30'
            BTFSC   STATUS, Z
            GOTO    CCBN

            SWAPF   HEL, W
            ANDLW   H'0F'
            ADDLW   H'30'
            GOTO    CCCBN

CCBN        MOVLW   H'20'
CCCBN       CALL    DATEN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MI          CLRF    ENABLE
            BSF     ENABLE, BIT1    ;FR MIN-ANZEIGE

            MOVF    MIN, W                  
            MOVWF   HEL

                        CALL    LOE

            BTFSS   PORTB, BIT1
            GOTO    ARAMIN
            CALL    ROEMISCH
            GOTO    SE

;MIN-DARSTELLEN ARABISCH
ARAMIN      MOVLW   H'81'                  
            CALL    BEFEHL
            
            MOVF    HEL, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            MOVLW   H'80'                  
            CALL    BEFEHL

            SWAPF   HEL, W

            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

;;;;;;;;;;;;;;;;;;;;;;;
SE          CLRF    ENABLE
            BSF     ENABLE, BIT0    ;FR SEC-ANZEIGE

            MOVF    SEC, W                  
            MOVWF   HEL

                        CALL    LOE

            BTFSS   PORTB, BIT0
            GOTO    ARASEC
            CALL    ROEMISCH
            GOTO    ENDE1

;SEC-DARSTELLEN ARABISCH
ARASEC      MOVLW   H'81'                  
            CALL    BEFEHL
            
            MOVF    HEL, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            MOVLW   H'80'                  
            CALL    BEFEHL

            SWAPF   HEL, W

            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN


ENDE1   POP
        RETFIE


;*****************************************************************************
;*                              UNTERPROGRAMM 1MSEC ZEITSCHLEIFE             *
;*                              03.01.14                                     *
;*****************************************************************************
ZS1MSEC_T0              MOVLW   D'6'
                        MOVWF   TMR0                    
                        BCF     INTCON, T0IF            ;OVERFLOW = 0
                
ZS11                    BTFSS   INTCON, T0IF            
                        GOTO    ZS11                   
                        RETURN

;ZEITBERECHNUNG FUER 1MS

;PRESCALER 16  *  SYSTEM 4X  * TAKTZEIT ====> 16*4*0.0625SEC=4SEC 
;1MS : 8SEC= 250                                       

;TMR0 ALSO D'256'-D'250'=D'6' ENTSPRICHT GENAU 1MSEC
;6 DEZIMAL OBEN EINTRAGEN

;*****************************************************************************
;*                              UNTERPROGRAMM 2MSEC ZEITSCHLEIFE+LSCHEN     *
;*****************************************************************************
LOE                     

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'84' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'85' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'86' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'87' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            RETURN


                        ;MOVLW   H'01'       ;CLEAR DISPLAY
                        ;CALL    BEFEHL

                        ;MOVLW   D'2'        ;2MSEC
                        ;MOVWF   HELP2

;LOE12                   MOVLW   D'200'
                        ;MOVWF   HELP1

;LOE11                   NOP         ;T=4
                        ;NOP         ;T=4
                        ;NOP         ;T=4
                        ;NOP         ;T=4
                        ;NOP         ;T=4

                        ;NOP         ;T=4
                        ;NOP         ;T=4
                        ;NOP         ;T=4
                        ;NOP         ;T=4
                        ;NOP         ;T=4

                        ;NOP         ;T=4
                        ;NOP         ;T=4
                        ;NOP         ;T=4
                        ;NOP         ;T=4
                        ;NOP         ;T=4
                        
                        ;NOP         ;T=4
                        ;NOP         ;T=4
                        ;NOP         ;T=4
                        ;NOP         ;T=4
                        ;NOP         ;T=4    GES.: 20*4T=80T   80T*0,0625SEC=5SEC    5SEC*200=1MSEC

                        ;DECFSZ  HELP1, F
                        ;GOTO    LOE11

                        ;DECFSZ  HELP2, F
                        ;GOTO    LOE12

                        ;RETURN

;*****************************************************************************
;*                              UNTERPROGRAMM 1SEC ZEITSCHLEIFE              *
;*                              _T1 STEHT FR TIMER1                         *
;*                              03.01.14                                     *
;*****************************************************************************
;ZS1SEC_T1     MOVWF    HELP2

;PP3           MOVLW   D'10'
;              MOVWF   HELP1

;PP2           BCF     PIR1, TMR1IF        ;OVERFLOW 0 MACHEN  
;              MOVLW   0XAF                ;ZEIT JEDES MAL NEU EINSTELLEN LOW-BYTE
;              MOVWF   TMR1L               ;
;              MOVLW   0X3C                ;ZEIT JEDES MAL NEU EINSTELLEN HIGH-BYTE
;              MOVWF   TMR1H               ;

;              MOVLW   0X31
;              MOVWF   T1CON              ;START TIMER 1 + INIT
      

;PP1           BTFSS   PIR1, TMR1IF        ;SPRUNG BEI OVERFLOW = 1 ,WENN ZEIT ERREICHT
;              GOTO    PP1

;              BCF     T1CON, TMR1ON       ;STOP TIMER1        
;              DECFSZ  HELP1, F
;              GOTO    PP2

;              DECFSZ  HELP2, F            ;SPRUNG BEI 0       
;              GOTO    PP3            
;              RETURN

;ZEITBERECHNUNG FR 100MSEC
;HIER MUSS MAN IN DEM DATENBLATT (DATASHEET) BEI WWW.MICROCHIP.COM (EIN *.PDF-FILE) NACHSEHEN,
;WIE ALLES FUNKTIONIERT

;PRESCALER 8X  *  SYSTEM 4X  * TAKTZEIT ====> 8*4*0.0625SEC=2SEC 
;100MS : 2SEC= 50000                                      
;DA ES 2 BYTE SIND FR DIE ZEIT IST DIE GRSSTE ZAHL 0XFFFF = D'65535'
;ALSO
;0XFFFF (D'65535') - D'50000' (0XC350) = 0X3CAF (D'15535')
;TMR1L = 0XAF  UND  TMR1H = 0X3C  DIES OBEN EINTRAGEN

;WIRD NUR MIT DEM FAKTOR 10 MAL MEHR DURCHLAUFEN (SIEHE HELP1)




;*****************************************************************************
;*                              DATEN AUSGEBEN AUF DOT-LCD-MODUL             *
;*                              04.05.10                                     *
;*****************************************************************************
DATEN       BSF     PORTA, RS               ;ALS DATEN

            MOVWF   BIT

            MOVF    PORTB, W
            ANDLW   0X0F
            MOVWF   MERK

            MOVF    BIT, W
            ANDLW   0XF0
            ADDWF   MERK, W
            MOVWF   PORTB


            BTFSS   ENABLE, BIT0
            GOTO    DE1
            BSF     PORTA, EN0
            GOTO    DEX

DE1         BTFSS   ENABLE, BIT1
            GOTO    DE2
            BSF     PORTA, EN1
            GOTO    DEX

DE2         BSF     PORTA, EN2


;ZEITSCHLEIFE 4SEC
DEX         MOVLW   D'4'                    ;UNGEFAEHR 4SEC ZEITSCHLEIFE
            MOVWF   HELP
D1          NOP                             ;T=4
            DECFSZ  HELP, F                 ;T=4
            GOTO    D1                      ;T=8    GES.:16TAKTE * 0,0625SEC= 1SEC    *4 DURCHLAEUFE= 4SEC
;ENDE ZEITSCHLEIFE
 
            BCF     PORTA, EN0
            BCF     PORTA, EN1
            BCF     PORTA, EN2

;---------------------------------

;LOW 4BIT AUSGEBEN
            SWAPF   BIT, F
            ;RLF     BIT, F
            ;RLF     BIT, F
            ;RLF     BIT, F
            ;RLF     BIT, F

            MOVF    PORTB, W
            ANDLW   0X0F
            MOVWF   MERK

            MOVF    BIT, W
            ANDLW   0XF0
            ADDWF   MERK, W
            MOVWF   PORTB


            BTFSS   ENABLE, BIT0
            GOTO    DA1
            BSF     PORTA, EN0
            GOTO    DEX1

DA1         BTFSS   ENABLE, BIT1
            GOTO    DA2
            BSF     PORTA, EN1
            GOTO    DEX1

DA2         BSF     PORTA, EN2


;ZEITSCHLEIFE 4SEC
DEX1        MOVLW   D'4'                    
            MOVWF   HELP
DDD1        NOP                             
            DECFSZ  HELP, F                
            GOTO    DDD1                    
;ENDE ZEITSCHLEIFE
 
            BCF     PORTA, EN0
            BCF     PORTA, EN1
            BCF     PORTA, EN2

;ZEITSCHLEIFE 40SEC
            MOVLW   D'40'                   ;UNGEFAEHR 40SEC ZEITSCHLEIFE SIEHE OBEN
            MOVWF   HELP
DDDD1       NOP
            DECFSZ  HELP, F                
            GOTO    DDDD1
;ENDE ZEITSCHLEIFE

            RETURN

;*****************************************************************************
;*                              BEFEHL AUSGEBEN AUF DOT-LCD-MODUL            *
;*                              04.05.10                                     *
;*****************************************************************************
BEFEHL      BCF     PORTA, RS                ;ALS BEFEHL

            MOVWF   BIT

            MOVF    PORTB, W
            ANDLW   0X0F
            MOVWF   MERK

            MOVF    BIT, W
            ANDLW   0XF0
            ADDWF   MERK, W
            MOVWF   PORTB


            BTFSS   ENABLE, BIT0
            GOTO    DB1
            BSF     PORTA, EN0
            GOTO    DEX2

DB1         BTFSS   ENABLE, BIT1
            GOTO    DB2
            BSF     PORTA, EN1
            GOTO    DEX2

DB2         BSF     PORTA, EN2


;ZEITSCHLEIFE 4SEC
DEX2        MOVLW   D'4'                   
            MOVWF   HELP
B1          NOP                             
            DECFSZ  HELP, F               
            GOTO    B1                      
;ENDE ZEITSCHLEIFE
 
            BCF     PORTA, EN0
            BCF     PORTA, EN1
            BCF     PORTA, EN2

;---------------------------------

;LOW 4BIT AUSGEBEN
            SWAPF   BIT, F
            ;RLF     BIT, F
            ;RLF     BIT, F
            ;RLF     BIT, F
            ;RLF     BIT, F

            MOVF    PORTB, W
            ANDLW   0X0F
            MOVWF   MERK

            MOVF    BIT, W
            ANDLW   0XF0
            ADDWF   MERK, W
            MOVWF   PORTB


            BTFSS   ENABLE, BIT0
            GOTO    DC1
            BSF     PORTA, EN0
            GOTO    DEX3

DC1         BTFSS   ENABLE, BIT1
            GOTO    DC2
            BSF     PORTA, EN1
            GOTO    DEX3

DC2         BSF     PORTA, EN2

;ZEITSCHLEIFE 4SEC
DEX3        MOVLW   D'4'                    
            MOVWF   HELP
BBB1        NOP                             
            DECFSZ  HELP, F                
            GOTO    BBB1                    
;ENDE ZEITSCHLEIFE
 
            BCF     PORTA, EN0
            BCF     PORTA, EN1
            BCF     PORTA, EN2

;ZEITSCHLEIFE 40SEC
            MOVLW   D'40'                   
            MOVWF   HELP
BBBB1       NOP
            DECFSZ  HELP, F                
            GOTO    BBBB1
;ENDE ZEITSCHLEIFE
 
            RETURN


;*****************************************************************************
;*                              ROEMISCH AUSGEBEN AUF DOT-LCD-MODUL          *
;*                              08.02.17                                     *
;*****************************************************************************
ROEMISCH
            MOVLW   H'30'
            SUBWF   HEL, W
            BTFSC   STATUS, C  ;GRER GLEICH HIGH
            GOTO    NEXT30

            MOVF    HEL, W
            SUBLW   H'00'
            BTFSS   STATUS, Z
            GOTO    NEXT01

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "0"
            CALL    DATEN
            RETURN
   
NEXT01      MOVF    HEL, W
            SUBLW   H'01'
            BTFSS   STATUS, Z
            GOTO    NEXT02

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN
   
NEXT02      MOVF    HEL, W
            SUBLW   H'02'
            BTFSS   STATUS, Z
            GOTO    NEXT03

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN 
  
NEXT03      MOVF    HEL, W
            SUBLW   H'03'
            BTFSS   STATUS, Z
            GOTO    NEXT04

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN
   
NEXT04      MOVF    HEL, W
            SUBLW   H'04'
            BTFSS   STATUS, Z
            GOTO    NEXT05

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN
            RETURN
   
NEXT05      MOVF    HEL, W
            SUBLW   H'05'
            BTFSS   STATUS, Z
            GOTO    NEXT06

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN
            RETURN

   
NEXT06      MOVF    HEL, W
            SUBLW   H'06'
            BTFSS   STATUS, Z
            GOTO    NEXT07

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

   
NEXT07      MOVF    HEL, W
            SUBLW   H'07'
            BTFSS   STATUS, Z
            GOTO    NEXT08

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

   
NEXT08      MOVF    HEL, W
            SUBLW   H'08'
            BTFSS   STATUS, Z
            GOTO    NEXT09

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN
   
NEXT09      MOVF    HEL, W
            SUBLW   H'09'
            BTFSS   STATUS, Z
            GOTO    NEXT10

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN
            RETURN

   
NEXT10      MOVF    HEL, W
            SUBLW   H'10'
            BTFSS   STATUS, Z
            GOTO    NEXT11

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN
            RETURN
   
NEXT11      MOVF    HEL, W
            SUBLW   H'11'
            BTFSS   STATUS, Z
            GOTO    NEXT12

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN
   
NEXT12      MOVF    HEL, W
            SUBLW   H'12'
            BTFSS   STATUS, Z
            GOTO    NEXT13

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

   
NEXT13      MOVF    HEL, W
            SUBLW   H'13'
            BTFSS   STATUS, Z
            GOTO    NEXT14

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN
   
NEXT14      MOVF    HEL, W
            SUBLW   H'14'
            BTFSS   STATUS, Z
            GOTO    NEXT15

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN
            RETURN
   
NEXT15      MOVF    HEL, W
            SUBLW   H'15'
            BTFSS   STATUS, Z
            GOTO    NEXT16

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN
            RETURN
   
NEXT16      MOVF    HEL, W
            SUBLW   H'16'
            BTFSS   STATUS, Z
            GOTO    NEXT17

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN
   
NEXT17      MOVF    HEL, W
            SUBLW   H'17'
            BTFSS   STATUS, Z
            GOTO    NEXT18

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN
   
NEXT18      MOVF    HEL, W
            SUBLW   H'18'
            BTFSS   STATUS, Z
            GOTO    NEXT19

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'84' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN
   
NEXT19      MOVF    HEL, W
            SUBLW   H'19'
            BTFSS   STATUS, Z
            GOTO    NEXT20

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN
            RETURN
   
NEXT20      MOVF    HEL, W
            SUBLW   H'20'
            BTFSS   STATUS, Z
            GOTO    NEXT21

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN
            RETURN

NEXT21      MOVF    HEL, W
            SUBLW   H'21'
            BTFSS   STATUS, Z
            GOTO    NEXT22

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT22      MOVF    HEL, W
            SUBLW   H'22'
            BTFSS   STATUS, Z
            GOTO    NEXT23

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT23      MOVF    HEL, W
            SUBLW   H'23'
            BTFSS   STATUS, Z
            GOTO    NEXT24

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'84' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT24      MOVF    HEL, W
            SUBLW   H'24'
            BTFSS   STATUS, Z
            GOTO    NEXT25

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN

            MOVLW   H'84' 
            CALL    BEFEHL
            RETURN

NEXT25      MOVF    HEL, W
            SUBLW   H'25'
            BTFSS   STATUS, Z
            GOTO    NEXT26

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN
            RETURN

NEXT26      MOVF    HEL, W
            SUBLW   H'26'
            BTFSS   STATUS, Z
            GOTO    NEXT27

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT27      MOVF    HEL, W
            SUBLW   H'27'
            BTFSS   STATUS, Z
            GOTO    NEXT28

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'84' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT28      MOVF    HEL, W
            SUBLW   H'28'
            BTFSS   STATUS, Z
            GOTO    NEXT29

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'84' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'85' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT29      MOVF    HEL, W
            SUBLW   H'29'
            BTFSS   STATUS, Z
            GOTO    NEXT30

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN
            RETURN

NEXT30      MOVF    HEL, W
            SUBLW   H'30'
            BTFSS   STATUS, Z
            GOTO    NEXT31

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN
            RETURN

NEXT31      MOVF    HEL, W
            SUBLW   H'31'
            BTFSS   STATUS, Z
            GOTO    NEXT32

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT32      MOVF    HEL, W
            SUBLW   H'32'
            BTFSS   STATUS, Z
            GOTO    NEXT33

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'84' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT33      MOVF    HEL, W
            SUBLW   H'33'
            BTFSS   STATUS, Z
            GOTO    NEXT34

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'84' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'85' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT34      MOVF    HEL, W
            SUBLW   H'34'
            BTFSS   STATUS, Z
            GOTO    NEXT35

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'84' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN
            RETURN

NEXT35      MOVF    HEL, W
            SUBLW   H'35'
            BTFSS   STATUS, Z
            GOTO    NEXT36

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN
            RETURN

NEXT36      MOVF    HEL, W
            SUBLW   H'36'
            BTFSS   STATUS, Z
            GOTO    NEXT37

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN

            MOVLW   H'84' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT37      MOVF    HEL, W
            SUBLW   H'37'
            BTFSS   STATUS, Z
            GOTO    NEXT38

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN

            MOVLW   H'84' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'85' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT38      MOVF    HEL, W
            SUBLW   H'38'
            BTFSS   STATUS, Z
            GOTO    NEXT39

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN

            MOVLW   H'84' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'85' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'86' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT39      MOVF    HEL, W
            SUBLW   H'39'
            BTFSS   STATUS, Z
            GOTO    NEXT40

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'84' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN
            RETURN

NEXT40      MOVF    HEL, W
            SUBLW   H'40'
            BTFSS   STATUS, Z
            GOTO    NEXT41

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN
            RETURN

NEXT41      MOVF    HEL, W
            SUBLW   H'41'
            BTFSS   STATUS, Z
            GOTO    NEXT42

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT42      MOVF    HEL, W
            SUBLW   H'42'
            BTFSS   STATUS, Z
            GOTO    NEXT43

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT43      MOVF    HEL, W
            SUBLW   H'43'
            BTFSS   STATUS, Z
            GOTO    NEXT44

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'84' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT44      MOVF    HEL, W
            SUBLW   H'44'
            BTFSS   STATUS, Z
            GOTO    NEXT45

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN
            RETURN

NEXT45      MOVF    HEL, W
            SUBLW   H'45'
            BTFSS   STATUS, Z
            GOTO    NEXT46

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN
            RETURN

NEXT46      MOVF    HEL, W
            SUBLW   H'46'
            BTFSS   STATUS, Z
            GOTO    NEXT47

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT47      MOVF    HEL, W
            SUBLW   H'47'
            BTFSS   STATUS, Z
            GOTO    NEXT48

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'84' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT48      MOVF    HEL, W
            SUBLW   H'48'
            BTFSS   STATUS, Z
            GOTO    NEXT49

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'84' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'85' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT49      MOVF    HEL, W
            SUBLW   H'49'
            BTFSS   STATUS, Z
            GOTO    NEXT50

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN
            RETURN

NEXT50      MOVF    HEL, W
            SUBLW   H'50'
            BTFSS   STATUS, Z
            GOTO    NEXT51

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN
            RETURN

NEXT51      MOVF    HEL, W
            SUBLW   H'51'
            BTFSS   STATUS, Z
            GOTO    NEXT52

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT52      MOVF    HEL, W
            SUBLW   H'52'
            BTFSS   STATUS, Z
            GOTO    NEXT53

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT53      MOVF    HEL, W
            SUBLW   H'53'
            BTFSS   STATUS, Z
            GOTO    NEXT54

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT54      MOVF    HEL, W
            SUBLW   H'54'
            BTFSS   STATUS, Z
            GOTO    NEXT55

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN
            RETURN

NEXT55      MOVF    HEL, W
            SUBLW   H'55'
            BTFSS   STATUS, Z
            GOTO    NEXT56

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN
            RETURN

NEXT56      MOVF    HEL, W
            SUBLW   H'56'
            BTFSS   STATUS, Z
            GOTO    NEXT57

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT57      MOVF    HEL, W
            SUBLW   H'57'
            BTFSS   STATUS, Z
            GOTO    NEXT58

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT58      MOVF    HEL, W
            SUBLW   H'58'
            BTFSS   STATUS, Z
            GOTO    NEXT59

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "V"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'84' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN
            RETURN

NEXT59      MOVF    HEL, W
            SUBLW   H'59'
            BTFSS   STATUS, Z
            GOTO    NEXT51

            MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "X"
            CALL    DATEN
            RETURN


            END


















